﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Spark.Installer;
using Proteus;

namespace Spark
{
    //Successs install, or canceled
    public partial class CompletionControl : BaseView
    {
        public CompletionControl(MainForm objForm)
        {
            InitializeComponent();
            Init(objForm);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }
        private void CompletionControl_Load(object sender, EventArgs e)
        {
            string strInstallOrUninstall = "";
            if (SparkGlobals.ProgramMode == SparkProgramMode.Uninstall)
                strInstallOrUninstall = "Uninstall";
            else if (SparkGlobals.ProgramMode == SparkProgramMode.Install)
                strInstallOrUninstall = "Install";
            else
                Globals.Throw("Invalid enumeration for completion window.");

            if (_objForm.GetInstaller().InstallState == InstallState.Canceled)
            {
                _lblInstallStatus.Text = strInstallOrUninstall + "Cancelled";
                _imgFailure.Visible = true;
                _imgSuccess.Visible = false;
            }
            else
            {
                _lblInstallStatus.Text = strInstallOrUninstall + " successful.\r\n\r\nPress exit to close this window.";
                _imgFailure.Visible = false;
                _imgSuccess.Visible = true;
            }

        }
    }
}
