﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace BuildGui
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class StartupLogoSplash : Window
    {
        public StartupLogoSplash()
        {
            InitializeComponent();
        }
        private void Delay(ulong ms)
        {
            ulong a = Proteus.Win32Utils.GetTickCount64();
            while (true)
            {
                ulong b = Proteus.Win32Utils.GetTickCount64();

                if (b - a > ms)
                    break;
                System.Windows.Forms.Application.DoEvents();
            }
        }
        public void SetStatusMsg(string msg)
        {
            _lblStatusMsg.Content = msg;
            Delay(20);
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Topmost = true;

            _imgLogo.Source = BuildGuiUtils.GetLogo();

        }
    }
}
