﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Proteus
{
    public class ConsoleProcessCommand
    {
        public ConsoleProcessCommandType CommandType { get; set; }
        public string CommandText { get; set; }
        public bool Synchronous;
        public ulong TimeoutInMilliseconds;
        public System.Threading.CancellationToken Token = System.Threading.CancellationToken.None;
        public ConsoleProcessCommand(string text, ConsoleProcessCommandType type, bool sync = false, ulong timeoutMs = 0, System.Threading.CancellationToken token = default(System.Threading.CancellationToken))
        {
            CommandType = type;
            CommandText = text;
            Synchronous = sync;
            TimeoutInMilliseconds = timeoutMs;
            Token = token;
        }
    }
}
