﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Reflection;
using Proteus;

namespace BuildGui
{
    /// <summary>
    /// Interaction logic for About.xaml
    /// </summary>
    public partial class About : Window
    {
        public About()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            _imgLogo.Source = BuildGuiUtils.GetLogo();
            string inf = "";

            inf += "Romulus Build System.\r\n";
            inf += "© Fulmination Interactive.\r\n";
            inf += "www.fulminationinteractive.com.\r\n\r\n";

            //Version v = Assembly.GetExecutingAssembly().GetName().Version;
            List<string> asmInfos = ReflectionUtils.GetAsmInfos();
            foreach (string str in asmInfos)
            {
                _lstAssemblies.Items.Add(str);
            }
            /*
            inf += "Romulus version "       + Proteus.Proteus.SystemInfo.RomulusVersion     + "\r\n"    ;
            inf += "Coordinator version "   + Proteus.Proteus.SystemInfo.CoordinatorVersion + "\r\n"    ;
            inf += "Agent version "         + Proteus.Proteus.SystemInfo.AgentVersion       + "\r\n"    ;
            inf += "Build Utility version " + Proteus.Proteus.SystemInfo.BuildGuiVersion    + "\r\n"    ;
            */
            _lblProgramInfo.Content = inf;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }
    }
}
