﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
namespace Proteus
{

    public class Win32Utils
    {

        class WinOps
        {
            // [System.Runtime.InteropServices.DllImport("kernel32.dll")]
            // static extern uint GetTickCount();
            [DllImport("kernel32.dll")]
            public static extern ulong GetTickCount64();
            [DllImport("kernel32.dll")]
            public static extern IntPtr GetConsoleWindow();
            [DllImport("user32.dll")]
            public static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

            public const int SW_HIDE = 0;
            public const int SW_SHOW = 5;
        }

        public static ulong GetTickCount64()
        {
            return WinOps.GetTickCount64();
        }
        public static void ShowConsole(bool blnShow)
        {
            var handle = WinOps.GetConsoleWindow();
            if(blnShow)
                WinOps.ShowWindow(handle, WinOps.SW_SHOW);
            else
                WinOps.ShowWindow(handle, WinOps.SW_HIDE);
        }
    
    }
}
